Name: logtalk
Summary: Logtalk - Open source object-oriented logic programming language
Version: 3.11.2
Release: 1
License: ASL 2.0
Group: Development/Languages
Packager: Paulo Moura <pmoura@logtalk.org>
Source: http://logtalk.org/files/logtalk-3.11.2-stable.tar.bz2
BuildArchitectures: noarch
URL: http://logtalk.org/
AutoReqProv: no
%description
Logtalk is an object-oriented logic programming language that can use most Prolog implementations as a back-end compiler. As a multi-paradigm language, it includes support for both prototypes and classes, protocols (interfaces), component-based programming through category-based composition, event-driven programming, and high-level multi-threading programming.

%prep
%setup -q -c logtalk-3.11.2-stable -n logtalk-3.11.2-stable

%build

%install
rm -rf $RPM_BUILD_ROOT
cd scripts
mkdir -p $RPM_BUILD_ROOT/usr/local
./install.sh -p $RPM_BUILD_ROOT/usr/local

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc /usr/local/share/logtalk-3.11.2-stable/ACKNOWLEDGMENTS.md
%doc /usr/local/share/logtalk-3.11.2-stable/BIBLIOGRAPHY.bib
%doc /usr/local/share/logtalk-3.11.2-stable/CONTRIBUTING.md
%doc /usr/local/share/logtalk-3.11.2-stable/CUSTOMIZE.md
%doc /usr/local/share/logtalk-3.11.2-stable/INSTALL.md
%doc /usr/local/share/logtalk-3.11.2-stable/LICENSE.txt
%doc /usr/local/share/logtalk-3.11.2-stable/NOTICE.txt
%doc /usr/local/share/logtalk-3.11.2-stable/QUICK_START.md
%doc /usr/local/share/logtalk-3.11.2-stable/README.md
%doc /usr/local/share/logtalk-3.11.2-stable/RELEASE_NOTES.md
%doc /usr/local/share/logtalk-3.11.2-stable/UPGRADING.md
/usr/local/share/logtalk-3.11.2-stable/VERSION.txt
/usr/local/share/logtalk-3.11.2-stable/loader-sample.lgt
/usr/local/share/logtalk-3.11.2-stable/settings-sample.lgt
/usr/local/share/logtalk-3.11.2-stable/tester-sample.lgt
/usr/local/share/logtalk-3.11.2-stable/tests-sample.lgt
/usr/local/share/logtalk-3.11.2-stable/adapters
/usr/local/share/logtalk-3.11.2-stable/coding
/usr/local/share/logtalk-3.11.2-stable/contributions
/usr/local/share/logtalk-3.11.2-stable/core
%doc /usr/local/share/logtalk-3.11.2-stable/docs
/usr/local/share/logtalk-3.11.2-stable/examples
/usr/local/share/logtalk-3.11.2-stable/integration
/usr/local/share/logtalk-3.11.2-stable/library
/usr/local/share/logtalk-3.11.2-stable/paths
/usr/local/share/logtalk-3.11.2-stable/man
%doc /usr/local/share/logtalk-3.11.2-stable/manuals
/usr/local/share/logtalk-3.11.2-stable/scratch
/usr/local/share/logtalk-3.11.2-stable/scripts
/usr/local/share/logtalk-3.11.2-stable/tests
/usr/local/share/logtalk-3.11.2-stable/tools
/usr/local/share/logtalk
/usr/local/bin/logtalk_user_setup
/usr/local/bin/lgt2pdf
/usr/local/bin/lgt2html
/usr/local/bin/lgt2xml
/usr/local/bin/lgt2md
/usr/local/bin/lgt2txt
/usr/local/bin/logtalk_tester
/usr/local/bin/logtalk_doclet
/usr/local/bin/logtalk_version_select
/usr/local/bin/logtalk_backend_select
/usr/local/bin/bplgt
/usr/local/bin/cxlgt
/usr/local/bin/eclipselgt
/usr/local/bin/gplgt
/usr/local/bin/jiplgt
/usr/local/bin/lplgt
/usr/local/bin/qplgt
/usr/local/bin/quintuslgt
/usr/local/bin/sicstuslgt
/usr/local/bin/swilgt
/usr/local/bin/xsblgt
/usr/local/bin/xsbmtlgt
/usr/local/bin/yaplgt
/usr/local/share/man/man1/bplgt.1.gz
/usr/local/share/man/man1/ciaolgt.1.gz
/usr/local/share/man/man1/cxlgt.1.gz
/usr/local/share/man/man1/eclipselgt.1.gz
/usr/local/share/man/man1/gplgt.1.gz
/usr/local/share/man/man1/jiplgt.1.gz
/usr/local/share/man/man1/lgt2html.1.gz
/usr/local/share/man/man1/lgt2pdf.1.gz
/usr/local/share/man/man1/lgt2xml.1.gz
/usr/local/share/man/man1/lgt2md.1.gz
/usr/local/share/man/man1/lgt2txt.1.gz
/usr/local/share/man/man1/logtalk_backend_select.1.gz
/usr/local/share/man/man1/logtalk_tester.1.gz
/usr/local/share/man/man1/logtalk_doclet.1.gz
/usr/local/share/man/man1/logtalk_user_setup.1.gz
/usr/local/share/man/man1/logtalk_version_select.1.gz
/usr/local/share/man/man1/lplgt.1.gz
/usr/local/share/man/man1/qplgt.1.gz
/usr/local/share/man/man1/quintuslgt.1.gz
/usr/local/share/man/man1/sicstuslgt.1.gz
/usr/local/share/man/man1/swilgt.1.gz
/usr/local/share/man/man1/xsblgt.1.gz
/usr/local/share/man/man1/xsbmtlgt.1.gz
/usr/local/share/man/man1/yaplgt.1.gz
%exclude /usr/local/share/mime

%post
echo
echo "Installed Logtalk on \"/usr/local/share\"."
echo

echo "Links to the \"logtalk_user_setup\", \"logtalk_backend_select\","
echo "\"logtalk_version_select\", \"logtalk_tester\", \"logtalk_doclet\","
echo "\"lgt2pdf\", \"lgt2html\", \"lgt2xml\", \"lgt2md\", and \"lgt2txt\""
echo "scripts have been created on \"/usr/local/bin\";"
echo "ensure that this directory is in your execution path."
echo
echo "The following integration scripts are installed for running Logtalk"
echo "with selected back-end Prolog compilers:"
echo
echo "* B-Prolog (version 7.8 or later):         bplgt"
echo "* CxProlog (version 0.98.1 or later):      cxlgt"
echo "* ECLiPSe (version 6.1#143 or later):      eclipselgt"
echo "* GNU Prolog (version 1.4.2 or later):     gplgt"
echo "* JIProlog (version 4.1.2.8 or later):     jiplgt      (first run may require sudo)"
echo "* Lean Prolog (version 4.5.4 or later):    lplgt       (experimental)"
echo "* Qu-Prolog (version 9.7 or later):        qplgt"
echo "* Quintus Prolog (version 3.3 or later):   quintuslgt  (experimental)"
echo "* SICStus Prolog (version 4.1.0 or later): sicstuslgt"
echo "* SWI-Prolog (version 6.6.0 or later):     swilgt"
echo "* XSB (version 3.5.0 or later):            xsblgt      (first run may require sudo)"
echo "* XSB MT (version 3.5.0 or later):         xsbmtlgt    (first run may require sudo)"
echo "* YAP (version 6.3.4 or later):            yaplgt"
echo
echo "Links to the Prolog integration scripts can be found on \"/usr/local/bin\"."
echo "Make sure that the Prolog compilers are properly installed and available"
echo "on your execution path."
echo
echo "If you get an unexpected failure when using one of the Prolog integration"
echo "scripts, consult the \"/usr/local/share/logtalk/adapters/NOTES.md\" file"
echo "for compatibility notes or consult the integration script man page."
echo
mkdir -p /etc/profile.d
echo "# Logtalk environment setup" > /etc/profile.d/logtalk.sh
echo "" >> /etc/profile.d/logtalk.sh
echo "# Logtalk installation directory:" >> /etc/profile.d/logtalk.sh
echo "export LOGTALKHOME=/usr/local/share/logtalk" >> /etc/profile.d/logtalk.sh
echo "" >> /etc/profile.d/logtalk.sh
echo "# Default location for Logtalk end-user files:" >> /etc/profile.d/logtalk.sh
echo "export LOGTALKUSER=\$HOME/logtalk" >> /etc/profile.d/logtalk.sh
chmod a+x /etc/profile.d/logtalk.sh
echo "# Logtalk environment setup" > /etc/profile.d/logtalk.csh
echo "" >> /etc/profile.d/logtalk.csh
echo "# Logtalk installation directory:" >> /etc/profile.d/logtalk.csh
echo "setenv LOGTALKHOME /usr/local/share/logtalk" >> /etc/profile.d/logtalk.csh
echo "" >> /etc/profile.d/logtalk.csh
echo "# Default location for Logtalk end-user files:" >> /etc/profile.d/logtalk.csh
echo "setenv LOGTALKUSER \$HOME/logtalk" >> /etc/profile.d/logtalk.csh
chmod a+x /etc/profile.d/logtalk.csh
echo "Defined the following environment variables for all users:"
echo
echo "  Logtalk installation directory: LOGTALKHOME = /usr/local/share/logtalk"
echo "  Default Logtalk user files directory: LOGTALKUSER = \$HOME/logtalk"
echo
echo "You may need to logout and login again or start a new shell in order to"
echo "use the new environment variables."
echo
echo "Users may change the default value of the LOGTALKUSER environment variable"
echo "in their shell configuration files if they already use, or want to use, a "
echo "different location for the Logtalk user files directory. This directory "
echo "is created by running the \"logtalk_user_setup\" shell script, which must"
echo " be run once by each user before using the integration scripts."
echo
if [ -x /usr/bin/update-mime-database ]; then
	mkdir -p /usr/share/mime/packages
	rm -f /usr/share/mime/packages/logtalk.xml
	cp /usr/local/share/logtalk-3.11.2-stable/scripts/freedesktop/logtalk.xml /usr/share/mime/packages/logtalk.xml
	update-mime-database /usr/share/mime
	echo "Added the Logtalk mime-type to the Shared MIME-info Database."
	echo
fi
echo "Logtalk basic installation completed."
echo

%postun
rm -f /etc/profile.d/logtalk.sh 2> /dev/null
rm -f /etc/profile.d/logtalk.csh 2> /dev/null
